from typing import Dict, List, Optional, Tuple
from scipy.stats import chisquare
from axelrod.action import Action
from axelrod.player import Player
from axelrod.strategy_transformers import FinalTransformer
from .memoryone import MemoryOnePlayer
lIlllllI, lIIllllIllIllIIIII = Action.C, Action.D
class IlIIIlllllllI(Player):
    lIIlIlIIIllIIllIlII = "strategy"
    IlIlIlIl = {
        "memory_depth": 1,
        "stochastic": True,
        "long_run_time": False,
        "inspects_source": False,
        "manipulates_source": False,
        "manipulates_state": False,
    }
    def IllIllIlI(IlIIIlII, IIIIllllIIIlIIIllIII: Player) -> Action:
        if len(IlIIIlII.history) == 0 or IlIIIlII.history[-1] == IIIIllllIIIlIIIllIII.history[-1]:
            return lIlllllI
        return IlIIIlII._random.random_choice(2 / 7)